
/*----------------------------------------------- topbar buttons click -------------------------------------------------*/
{
    function delete_click() {
        var obj = document.getElementById("delete_btn_img");
        obj.src = "./icons/Delete_p.png";
        obj = document.getElementById("delete_btn");
        obj.style.borderColor = "#923094";    
    }
    
    function delete_up(){
        var obj = document.getElementById("delete_btn_img");
        obj.src = "./icons/Delete.png";
        obj = document.getElementById("delete_btn");
        obj.style.borderColor = "#d6d6d6";
    
        showConfirmDialog("delete_files",
                                                    "Delete",
                                                    "Are you sure you want to delete the file(s) ? " );
        
    }
    
    function download_click() {
        var obj = document.getElementById("download_btn_img");
        obj.src = "./icons/download_p.png";
        obj = document.getElementById("download_btn");
        obj.style.borderColor = "#923094";
    }
    
    function download_up() {
        var obj = document.getElementById("download_btn_img");
        obj.src = "./icons/Download.png";
        obj = document.getElementById("download_btn");
        obj.style.borderColor = "#d6d6d6";
    
        for (var i = 0; i < g_selectIdxArray.length; ++i) {
            doDownloadFile(g_files[g_selectIdxArray[i]].path);
        }
    }
    
    function upload_click() {
        var obj = document.getElementById("upload_btn_img");
        obj.src = "./icons/upload_p.png";
        obj = document.getElementById("upload_btn_p");
        obj.style.color = "#923094";
        obj = document.getElementById("upload_btn");
        obj.style.borderColor = "#923094";
    
    }
    
    function upload_up() {
        var obj = document.getElementById("upload_btn_img");
        obj.src = "./icons/upload.png";
        obj = document.getElementById("upload_btn_p");
        obj.style.color = "#000";
        obj = document.getElementById("upload_btn");
        obj.style.borderColor = "#d6d6d6";

        var selectFile = document.createElement("input");
        selectFile.setAttribute("type", "file");
        selectFile.setAttribute("multiple", "multiple");
        selectFile.addEventListener("change", function() {
           var f = "";
           for (var i = 0; i < this.files.length; i++) {
                const taskInfo = new Map();
                taskInfo.set('fobj', this.files[i]);
                 addNewUploadTask(taskInfo);
           }
        });
        selectFile.click();
        
        document.body.appendChild(selectFile);
        document.body.removeChild(selectFile);
    }
    
    function tranlist_click() {
        var obj = document.getElementById("tranlist_btn_img");
        obj.src = "./icons/tranlist_p.png";
        obj = document.getElementById("tranlist_btn_p");
        obj.style.color = "#923094";
        obj = document.getElementById("tranlist_btn");
        obj.style.borderColor = "#923094";
    }
    
    function tranlist_up() {
        var obj = document.getElementById("tranlist_btn_img");
        obj.src = "./icons/tranlist.png";
        obj = document.getElementById("tranlist_btn_p");
        obj.style.color = "#000";
        obj = document.getElementById("tranlist_btn");
        obj.style.borderColor = "#d6d6d6";
    
        showTranlistView();
    
    }

    function doDeleteSelectFiles() {
        var sep = "#" + getRandomString() + "#";
        var files = "";
         for (var i = 0; i < g_selectIdxArray.length; i++) {
            files += (g_files[g_selectIdxArray[i]].path + sep);
         }
         var data = '{"sep":' + '"' + sep + '"'+ ', "files":' + '"' + files + '" }';
         
         url = "/del&"
         var xhr = new XMLHttpRequest();
         xhr.open("POST", url);
         xhr.setRequestHeader("Content-type", "application/jason;character=UTF-8");
         xhr.send(data);
     
         xhr.onreadystatechange = function () {
             if (this.readyState == 4 && this.status == 200) {
                var  result = JSON.parse(this.responseText);
                if (result.ret == "success") {
                     updatePath(g_path);
                }
             }
         }
    }
    
    function getRandomString() {
        let _charStr = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789",
                min = 0,
                max = _charStr.length - 1,
                _str = "";
                
        var len = 15;
        for (var i = 0, index; i < len; i++) {  
            index = (function (randomIndexFunc, i) {
                    return randomIndexFunc(min, max, i, randomIndexFunc);
             })(function(min, max, i, _self) {
                let indexTemp = Math.floor(Math.random() * (max - min + 1) + min),
                        numStart = _charStr.length - 10;
                        if (i == 0 && indexTemp >= numStart) {
                            indexTemp = _self(min, max, i, _self);
                        }
                        return indexTemp;
             }, i);
             _str += _charStr[index];
        }      
        return _str;
    }


}

/*------------------------------------------------ file list : ----------------------------------------------------------------*/
/*-------------------item click, hover, delete, download, open, selectAll ------------------------------------*/
{
    function item_mouseover(element) {
        element.style.backgroundColor = "#f6ecff";
        if (element.children[0].className == "file-ck") {
         element.children[3].children[0].children[0].style.width = "fit-content";
         element.children[3].children[0].children[1].style.width = "fit-content";
        } else {
            element.children[3].children[0].children[0].style.width = "fit-content";
        }
     
     }
     
     function item_mouseleave(element) {
         element.style.backgroundColor = "#fff";
         if (element.children[0].className == "file-ck") {
             element.children[3].children[0].children[0].style.width = "0%";
             element.children[3].children[0].children[1].style.width = "0%";
         } else {
            element.children[3].children[0].children[0].style.width = "0%";
         }
     }
     
     function item_onclick(element) {
         var item = g_files[element.parentNode.rowIndex];
         if (item.folder) {
             updatePath(item.path);
         } else {
             openFile(item.path);
         }
     }
     
     function showSelectBtns(show) {
         var deleteBtn = document.getElementById("delete_btn");
         var downloadBtn = document.getElementById("download_btn");
     
         deleteBtn.style.visibility =  show ? "visible" : "hidden";
         downloadBtn.style.visibility = show ? "visible" : "hidden";
     
         console.debug(show);
     }
     
     var g_selectAll = false;
     var g_selectIdxArray = [];
     var g_files_count = 0;
     var g_folders_count = 0;
     function selectAll_click() {
         g_selectAll = !g_selectAll;
     
         var table = document.getElementById("table");
         var size = table.rows.length;
         g_selectIdxArray.splice(0, g_selectIdxArray.length);
         for(var i = 0; i < size; i++) {
             var row = table.rows[i];
             if (row.children[0].className == "file-ck") {
                 if (g_selectAll) {
                     row.children[0].children[0].src = "./icons/checkbox_s.png";
                     g_selectIdxArray.push(i);
                 } else {
                     row.children[0].children[0].src = "./icons/checkbox.png";
                 }
             }
         }
     
         updateSelectStaus();
     
     }
     
     function fun_download_click(element) {
         var index = element.parentNode.parentNode.parentNode.rowIndex;
         var path = g_files[index].path;
     
         doDownloadFile(path);
     }
     
     function doDownloadFile(path) { 
        var link = document.createElement("a");
        link.href = "/download?" + path;
        var fileName = path.substring(path.lastIndexOf("/") + 1, path.length);
        link.download = fileName;
        document.querySelector("body").appendChild(link);
        link.click();
        document.querySelector("body").removeChild(link);
     }
     
     function doDeleteFile() {
         url = "/del&path=" + g_files[g_fun_row.rowIndex].path;
         var xhr = new XMLHttpRequest();
         xhr.open("DELETE", url);
        //  xhr.open("GET", url); @IOS
         xhr.send();
     
         xhr.onreadystatechange = function () {
             if (this.readyState == 4 && this.status == 200) {
                var  result = JSON.parse(this.responseText);
                if (result.ret == "success") {
                     updatePath(g_path);
                }
             }
         }
     
     }

     function openFile(path) {
        window.open("open?" + path, "_blank"); 
    }
    
    function updateSelectStaus() {
        g_selectAll =  (g_selectIdxArray.length == g_files_count && g_selectIdxArray.length != 0);

        var obj = document.getElementById("selectAll");
        g_selectAll ? obj.src="./icons/checkbox_s.png" : obj.src="./icons/checkbox.png";
    
        showSelectBtns(g_selectIdxArray.length > 0);
    }
    
    function item_oncheck(element){
       var rowid =  element.parentNode.parentNode.rowIndex;
       var index = g_selectIdxArray.indexOf(rowid);

       if (index >= 0) {
            g_selectIdxArray.splice(index, 1);
            element.src = "./icons/checkbox.png"
       } else {
            g_selectIdxArray.push(rowid);
            element.src = "./icons/checkbox_s.png"
       }
    
        updateSelectStaus();
    
    }
    

}

/*------------------------------------------------ transfer : upload, transfer list----------------------------------- */
{
    var g_taskList = [];
    function addNewUploadTask(task) {
        task.set("upload", 0); // 0 ready, 1 done
        g_taskList.push(task);
        createHtml_taskItem(task.get("fobj"));
        update_tranList();

        if (!g_startRunTask && g_timerID <= 0)  {
            runNextTask();
        }
    }

    function createHtml_taskItem(file) {
        var tbody = document.getElementById("tranlist-tbody");
        var tr = document.createElement("tr");
    
        tr.innerHTML = "<td><img src=\""  + getFileIcon(false, file.name.substring(file.name.lastIndexOf(".") + 1)) + "\"></td>" +
        "<td><div><div><p class=\"process-name\">" + file.name + "</p></div>" + 
        "<div class=\"process-info\"><div class=\"process-size\"><p>0B/" + fileSizeToString(file.size) + "</p></div>" +
        "<div class=\"process-line\"><div class=\"pl-color\" ></div></div></div></div></td>" +
        "<td><img onclick=\"javascript:fun_canceltask(this)\" src=\"./icons/Close.png\"></td>";
        tbody.appendChild(tr);
    }

    function update_tranList() {
        var count = document.getElementById("tranlist_count_str");
        count.innerHTML = "Transfer list ( Total : " + g_taskList.length + " )";

        cancelall_enabled(g_taskList.length > 0);

    }

    function fun_canceltask(element) {
        rowIdx = element.parentNode.parentNode.rowIndex;
        g_taskList.splice(rowIdx, 1);
        var tbody = document.getElementById("tranlist-tbody");
        tbody.removeChild(element.parentNode.parentNode);

        if (g_curTaskIdx == rowIdx) {
            if (g_timerID > 0) {
                g_uploadRequest.abort();
            }
           runNextTask();
        }
        update_tranList();
    }

    function showTranlistView() { 
        var popwindow = document.getElementById("tran_list");
        if (popwindow.clientWidth > 0) {
            popwindow.style.display = "none";
            showMask(false, popwindow);
            return;
        }
    
        showMask(true, popwindow);
        popwindow.style.display = "block";
        
    }

    function fileSizeToString (len) {
        var str = "0B"
        if (len < 1024) {
            str = len + "B";
        } else if  (len < 1024 * 1024) {
            str = (len / 1024 ).toFixed(1)+ "KB";
        } else  if (len < 1024 * 1024 * 1024) {
            str = (len / 1024 / 1024).toFixed(1) + "MB";
        } else {
            str = (len / 1024 / 1024 / 1024).toFixed(1) + "GB";
        }
        return str;

    }

    function cancelall_enabled(enabled) {
        if (enabled) {
            var obj = document.getElementById("cancelall_btn_img");
            obj.src = "./icons/Delete2.png";
            obj = document.getElementById("cancelall_btn_p");
            obj.style.color = "#000";
            obj = document.getElementById("cancelall_btn");
            obj.style.borderColor = "#d6d6d6";
            obj.style.cursor = "pointer";
            
        } else {
            var obj = document.getElementById("cancelall_btn_img");
            obj.src = "./icons/Delete2_d.png";
            obj = document.getElementById("cancelall_btn_p");
            obj.style.color = "#e2e2e2";
            obj = document.getElementById("cancelall_btn");
            obj.style.borderColor = "#e2e2e2";
            obj.style.cursor = "not-allowed";
        }
    }

    function cancelall_click() {
        if (g_taskList.length > 0) {
            var obj = document.getElementById("cancelall_btn_img");
            obj.src = "./icons/Delete2_p.png";
            obj = document.getElementById("cancelall_btn_p");
            obj.style.color = "#923094";
            obj = document.getElementById("cancelall_btn");
            obj.style.borderColor = "#923094";
        }
    }

    function cancelall_up() {
        if (g_taskList.length > 0) {
            var obj = document.getElementById("cancelall_btn_img");
            obj.src = "./icons/Delete2.png";
            obj = document.getElementById("cancelall_btn_p");
            obj.style.color = "#000";
            obj = document.getElementById("cancelall_btn");
            obj.style.borderColor = "#d6d6d6";

            var mask = document.getElementById("mask");
            mask.click();
            showConfirmDialog("clean", "Cancel All","Do you want to cancel all upload tasks?");
        }
    }

    var g_curTaskIdx;
    var g_timerID = 0;
    var g_startRunTask = false;
    function runNextTask() {
        g_startRunTask = true;

        if (g_timerID > 0) {
            clearTimeout(g_timerID);
        }

        g_timerID = 0;
        for(var i = 0; i < g_taskList.length; i++) {
            if (g_taskList[i].get("upload") == 0) {
                g_curTaskIdx = i;
                var tbody = document.getElementById("tranlist-tbody");
                var trItem = tbody.children[g_curTaskIdx];
                g_rate = 0;
                g_timerID = setTimeout(startUpload.bind(null, trItem, g_taskList[i]), 100);
                break;
            }
        }

        g_startRunTask = false;
    }

    var g_rate;
    var g_uploadRequest;
    function startUpload(trItem, task) {
        var url = "/upload&path=" + g_path;
        var form = new FormData();
        form.append("filename", task.get("fobj").name);
        form.append("size", task.get("fobj").size);
        form.append("file", task.get("fobj"));

        var totalStr =  fileSizeToString( task.get("fobj").size);
        g_uploadRequest = new XMLHttpRequest();
        g_uploadRequest.open("POST", url, true);
        g_uploadRequest.onload = function() {
            if (g_uploadRequest.readyState == 4 && g_uploadRequest.status == 200) {
                var data = JSON.parse(this.response);

               if (data.ret == 2) {
                    // upload done faild : cause FileNameTooLong - android
                    showWarningDialog("Upload Error. The document name exceeds the character limit.");
                } 

                //upload done success or other error (no need to show message)
                trItem.children[1].children[0].children[1].children[1].style.visibility = "hidden";
                trItem.children[1].children[0].children[1].children[0].children[0].innerHTML = 
                    totalStr + " Completed";
                task.set("upload", 1);
                refreshDir();
                runNextTask();
                
            }
        }   

        g_uploadRequest.upload.onprogress = function(evt) {
            g_rate = Math.round(evt.loaded / evt.total * 100);
            trItem.children[1].children[0].children[1].children[1].children[0].style.width = g_rate + "%";
            trItem.children[1].children[0].children[1].children[0].children[0].innerHTML =  fileSizeToString(evt.loaded) + "/" + totalStr;
        
        }
        g_uploadRequest.send(form);
    }

    function doCleanTranList() {
         if (g_timerID > 0) {
            g_uploadRequest.abort();
            clearTimeout(g_timerID);
        }
        g_timerID = 0;

        var tbody = document.getElementById("tranlist-tbody");
        tbody.innerHTML = "";
        g_taskList.splice(0, g_taskList.length);
        update_tranList();
    }

    var g_ref_timerID = 0;
    function refreshDir() {
        g_ref_timerID = setTimeout(function () {
            request_filelist();
            clearTimeout(g_ref_timerID);
        }, 100);
    }

}

/*------------------------------------------------ file list : path, get files -------------------------------------------- */
{
    function list_empty(a) {
        var emptyView = document.getElementById("empty_view");
     
        if (a) {
            emptyView.style.display="block";
        } else {
            emptyView.style.display="none";
        }
    }
    
    function path_back() {
        if (g_path == "/") return;
    
        var path = g_path.substring(0, g_path.lastIndexOf("/"));
        if (path.length < 1) {
            path = "/";
        }
    
        updatePath(path);
    }
    
    function path_root() {
        updatePath("/");
    }
    
    var g_path = "/";
    function updatePath(a) {
    
        var root = document.getElementById("path-root");
        var back = document.getElementById("path-back");
        var allFiles = document.getElementById("path-allfiles");
        var dirname = document.getElementById("path-dirname");
    
        g_path = a;
        var apath = a.split("/");
        dirname.children[0].innerHTML = apath[apath.length - 1];
        setCookie("path", g_path);
    
        if (g_path == "/") {
            root.style.display="block";
            back.style.display="none";
            allFiles.style.display="none";
            dirname.style.display="none";
        } else {
            root.style.display="none";
            back.style.display="block";
            allFiles.style.display="block";
            dirname.style.display="block";
        }
    
        g_selectIdxArray.splice(0, g_selectIdxArray.length);
        updateSelectStaus();
    
        //get file list
        request_filelist();
    }
    
    function request_filelist() {
        url = "/list&path=" + g_path;
        var xhr = new XMLHttpRequest();
        xhr.open("GET", url);
        xhr.send();
    
        xhr.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                g_files = JSON.parse(this.responseText);
                // g_files = JSON.parse(this.responseText).files; @IOS
                g_files_count = 0;
                g_folders_count = 0;
                createhtml_filelist();
                list_empty(g_files.length == 0);
            }
        }
    }
    
    var g_files = [];
    function createhtml_filelist() {
        var table = document.getElementById("table");
        var str = "<tbody>";
       
        for (var i = 0; i < g_files.length; i++) {
            var row = "<tr onmouseover=\"javascript:item_mouseover(this)\" onmouseleave=\"javascript:item_mouseleave(this)\">" +
            "<td " + ( g_files[i].folder ? "class=\"folder-ck\"> " :  "class=\"file-ck\"> ")  + "<img src=\"./icons/checkbox.png\" onclick=\" javascript:item_oncheck(this)\"></td>" +
            "<td><img src=\"" + getFileIcon(g_files[i].folder, g_files[i].ext) + "\"></td>" +
            "<td onclick=\"javascript:item_onclick(this)\"><p class=\"file-list-name\">" + g_files[i].name + "</p></td>" +
            "<td><div> <Img onclick=\"javascript:fun_del_click(this)\" src=\"./icons/Delete_p.png\"><img onclick=\"javascript:fun_download_click(this)\" src=\"./icons/download_p.png\"></div></td>" + 
            "<td><p>" + (g_files[i].folder ? "Folder" : "File") + "</p></td>" + 
            "<td><p>"+ g_files[i].time + "</p></td>" +
            "<td><p>" + g_files[i].size + "</p></td>" +"</td></tr>";
        
            str += row;
    
            /* count files */
            if (g_files[i].folder) {
                g_folders_count++;
            } else {
                g_files_count++;
            }
        }
        str += "</tbody>";
        table.innerHTML = str;
    }
    
    var g_fun_row;
    function fun_del_click(element) {
        g_fun_row = element.parentNode.parentNode.parentNode;
        showConfirmDialog("item_delete",
                                                    "Delete",
                                                    "Are you sure you want to delete the file(s) ? " );
    
    }
    
    function getFileIcon(folder, ext) {
        if (folder) {
            return "./icons/folders.png";
        } else {
            var str = "";
            if (ext.toLowerCase() == "pdf" || 
                    ext.toLowerCase() == "ofd" ||
                    ext.toLowerCase() == "ppdf") {
                str = "./icons/_trademark_file_doc.png";
            } else if (ext.toLowerCase() == "cpdf") {
                str = "./icons/file_cpdf.png";
            } else if (ext.toLowerCase() == "xlsx" || 
                                ext.toLowerCase() == "xls") {
                str = "./icons/file_excel.png";
            } else if (ext.toLowerCase() == "doc" ||
                                ext.toLowerCase() == "docx") {
                str = "./icons/file_word.png";
            } else if (ext.toLowerCase() == "txt") {
                str = "./icons/file_txt.png";
            } else if (ext.toLowerCase() == "pptx" || 
                                ext.toLowerCase() == "ppt" ) {
                str = "./icons/file_ppt.png";
            } else if (ext.toLowerCase() == "jpg" || 
                                ext.toLowerCase() == "png" ||
                                ext.toLowerCase() == "bmp" || 
                                ext.toLowerCase() == "gif" ||
                                ext.toLowerCase() == "svg" || 
                                ext.toLowerCase() == "tiff") {
                str = "./icons/file_img.png";
            } else if (ext.toLowerCase() == "zip") {    
                str = "./icons/file_zip.png";
            } else {
                str = "./icons/file_default.png";
            }
            return str;
        }
    }

}

/* ------------------------------------------------ init: loaded(); cookie(path) --------------------------------------*/
{
    var g_scrollWidth;

    function loaded() {
        updateSelectStaus();
        var path = getCookies("path");
        if (path == null) {
            path = "/";
        }
        updatePath(path);
        update_tranList();
    
    }
    
    function host() {
        return document.location.hostname + ":" + document.location.port;
    }

    // function computeScrollWidth() {
    //     var inner, outer, node = document.createElement("div");
    //     node.style.cssText = "position:absolute; top:-1000px; width:100px; height:100px; overflow:hidden;";
    //     inner = document.body.appendChild(node).clientWidth;
    //     node.style.overflowY = "scroll";
    //     outer = node.clientWidth;
    //     document.body.removeChild(node);
    //     g_scrollWidth = inner - outer;
    // }
    
    function setCookie(name, value) {
        var exp = new Date();
        exp.setTime(exp.getTime() + 24 * 60 * 60 * 1000 );
        document.cookie = name + "=" + value + "; Expires: " + exp.toLocaleTimeString() + "; path=/";
    }
    
    function getCookies(name) {
        var arr, reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
            if (arr = document.cookie.match(reg))
                return arr[2];
            else
                return null;
    }
}

/*------------------------------------------------- Confirm / Warning dialog -----------------------------------------------------*/
{
    function dlg_click_y(){
        var btn = document.getElementById("dlg-btn-y");
        btn.style.backgroundColor = "#923094";
        btn.style.color = "#fff";
    
    }
    
    function dlg_up_y(){
        var btn = document.getElementById("dlg-btn-y");
        btn.style.backgroundColor = "#fff";
        btn.style.color = "#333";
    
        var dlg = document.getElementById("dialog");
        var tag = dlg.getAttribute("tag");
        if (tag == "item_delete") {
            doDeleteFile();
        } else if (tag == "delete_files") {
            doDeleteSelectFiles();
        } else if (tag == "clean") {
            doCleanTranList();
        }
    
        dlg.style.display = "none";
        showMask(false, dlg);
        passivePage(true);
    }
    
    function dlg_click_n(){
        var btn = document.getElementById("dlg-btn-n");
        btn.style.backgroundColor = "#923094";
        btn.style.color = "#fff";
    }
    
    function dlg_up_n(){
        var btn = document.getElementById("dlg-btn-n");
        btn.style.backgroundColor = "#fff";
        btn.style.color = "#333";
    
        var dlg = document.getElementById("dialog");
        dlg.style.display = "none";
        showMask(false, dlg);
        passivePage(true);
    }
    
    function showConfirmDialog(tag, title, message) {
        var tl = document.getElementById("dlg-title");
        tl.children[0].innerHTML = title;
    
        var mg = document.getElementById("dlg-prompt");
        mg.children[0].innerHTML = message;
    
        var dlg = document.getElementById("dialog");
        dlg.setAttribute("tag", tag);
        dlg.style.display = "block";
    
        var no_btn = document.getElementById("dlg-btn-n");
        no_btn.style.display = "block";
        var no_btn = document.getElementById("btn-y");
        no_btn.innerHTML = "YES";


        showMask(true, dlg);
        passivePage(false);
    }

    function showWarningDialog(message) {
        var tl = document.getElementById("dlg-title");
        tl.children[0].innerHTML = "Warning";
    
        var mg = document.getElementById("dlg-prompt");
        mg.children[0].innerHTML = message;
    
        var dlg = document.getElementById("dialog");
        dlg.setAttribute("tag", "");
        dlg.style.display = "block";

        var no_btn = document.getElementById("dlg-btn-n");
        no_btn.style.display = "none";
        var no_btn = document.getElementById("btn-y");
        no_btn.innerHTML = "OK";

    
        showMask(true, dlg);
        passivePage(false);

    }
}

/*------------------------------------------------- mask, passivePage ----------------------------------------------- */
{
    function showMask(show, element) {
        var mask = document.getElementById("mask");
        mask.style.display =  (show ? "block" : "none");
    
        if (show) {
            mask.addEventListener("click", function() {
            element.style.display = "none";
            mask.style.display = "none";
            mask.removeEventListener("click", function() {});
            })
        }
    }
    
    function passivePage(able) {
        // scroll move disabled
        document.body.style.overflow = able ?  "auto" : "hidden";
    }


}
